/*                       ***  proj.cpp  ***
 * ******************************************************************
 * Copyright (c) T--------s Inc., 1992,  All rights reserved
 *
 * Programmer: Pete Melissakis         CompuServe 73500,1133
 *
 * Original Version 09-13-92 04:45pm
 *
 * Uses: proj.res
 *       bwcc.dll
 *       proj.def
 *       proj.mak
 *
 * Version 0.1  11-05-92 06:35pm
 *              Main window and timesheet dialog.
 *
 * BE WARNED --  I AM NOT A PROFESSIONAL PROGRAMMER AND ACCEPT NO
 * ACCOUNTABILITY WHATSOEVER FOR THIS CODE. FEEL FREE TO COPY ANY
 * PARTS AND USE AS YOU WISH.
 *
 * ******************************************************************
 */
#define  PROJ_CPP

#include <owl.h>
#include <dialog.h>
#include <windows.h>
#include <edit.h>
#include <strstrea.h>
#include <string.h>
#include <math.h>
#include <bwcc.h>
#include <stdio.h>
#include <mem.h>
#include "proj.hpp"

TDialog* CreateTSheet;   // To be used in TProjWindow to prevent
                         // multiple creations of the dialog box

//  -------------------------------- TValidate member     CanClose
BOOL  TValidate :: CanClose()
  {
  char* cp = new char[TextLen];
  GetText((LPSTR) cp, TextLen);
  BOOL result = Valid(cp);
  delete cp;
  return result;
  }

//  -------------------------------- TValidate member     Transfer
WORD  TValidate :: Transfer(Pvoid DataPtr, WORD TransferFlag)
  {
  char* cp = new char[TextLen];
  if(TransferFlag == TF_GETDATA)
    {
    GetText((LPSTR) cp, TextLen);
    if(Valid(cp))
      GetText((LPSTR) DataPtr, TextLen);
    }
  else if(TransferFlag == TF_SETDATA)
    SetText((LPSTR) DataPtr);
  delete  cp;
  return TextLen;
  }

//  -------------------------------- TValidate member     Valid
int   TValidate :: Valid(char* cp)
  {
  char* string = cp;
  char* character_set = CharacterSet();
  for(; *cp; cp++)
    {
    if(!strchr(character_set, *cp))
      {
      ErrorMessage(string);
      return  FALSE;
    } }
  return  TRUE;
  }

//  -------------------------------- TValidate member     ErrorMessage
void  TValidate :: ErrorMessage(char *cp)
  {
  ostrstream text(buffer, sizeof(buffer));
  text  <<  "The string '"
        <<  cp
        <<  "' is invalid !"
        <<  ends;
  BWCCMessageBox(NULL, buffer, "Data Entry Error",
                 MB_ICONEXCLAMATION | MB_TASKMODAL | MB_OK);
  }

//  -------------------------------- TValidate member     EmptyMessage
void  TValidate :: EmptyMessage(char *field)
  {
  ostrstream text(buffer, sizeof(buffer));
  text  <<  "You must enter\n-"
        <<  field
        <<  "- !"
        <<  ends;
  field = strupr(field);
  char  title[100];
  ostrstream Title(title, sizeof(title));
  Title <<  "Missing "
        <<  field
        <<  ends;
  BWCCMessageBox(NULL, buffer, title,
                 MB_ICONEXCLAMATION | MB_TASKMODAL | MB_OK);
  }

//  -------------------------------- TValidate member     CharacterSet
char* TValidate :: CharacterSet()
  {
  static  char  set[] =
    {
    "ABCDEFGHIGKLMNOPQRSTUVWXYZ"
    "abcdefghijklmnopqrstuvwxyz"
    "0123456789"
    " .,%'/-"
    };
  return set;
  }

//  -------------------------------- TStateEdit member    Valid
int   TStateEdit :: Valid(char* cp)
  {
  if(NULL == *cp)
    {
    TValidate :: EmptyMessage("State");
    return FALSE;
    }
  strupr(cp);
  if((NULL == (strstr(StateList, cp))) || (strlen(cp) < SZ_STATE-1))
    {
    ErrorMessage(cp);
    return  FALSE;
    }
  return  TRUE;
  }

//  -------------------------------- TStateEdit member    ErrorMessage
void  TStateEdit ::  ErrorMessage(char* cp)
  {
  ostrstream text(buffer, sizeof(buffer));
  text  <<  "The entry '"
        <<  cp
        <<  "' is not a state!"
        <<  ends;
  BWCCMessageBox(NULL, buffer, "Invalid state",
                 MB_ICONEXCLAMATION | MB_TASKMODAL | MB_OK);
  }

//  -------------------------------- constructor          TTSheetDlg
TTSheetDlg ::  TTSheetDlg(PTWindowsObject AParent)
                       :  TDialog(AParent, DIALOG_TIMESHEET)
  {
  new TComboBox(this, ID_EMPLNAME, SZ_EMPNAME);  // Same as SZ_SITE

  new TEdit(this, ID_EMPDATE,      SZ_DATE);
  new TEdit(this, ID_EMPTEO,       SZ_TEO);
  new TEdit(this, ID_EMPSITE,      SZ_SITE);     // Same as SZ_EMPNAME

  new TStateEdit(this, ID_EMPSTATE);          // State is validated before
                                              // Dialog can be closed
  new TEdit(this, ID_EMPTRAVEL,    SZ_HOURS);
  new TEdit(this, ID_EMPINSTALL,   SZ_HOURS);
  new TEdit(this, ID_EMPENGINEER,  SZ_HOURS);
  new TEdit(this, ID_EMPASBUILT,   SZ_HOURS);
  new TEdit(this, ID_EMPSURVEY,    SZ_HOURS);
  new TEdit(this, ID_EMPTEST,      SZ_HOURS);
  new TEdit(this, ID_EMPQUALITY,   SZ_HOURS);
  new TEdit(this, ID_EMPREWORK,    SZ_HOURS);
  new TEdit(this, ID_EMPSTAGING,   SZ_HOURS);
  new TEdit(this, ID_EMPDELIVER,   SZ_HOURS);
  new TEdit(this, ID_EMPPREWIRE,   SZ_HOURS);
  new TEdit(this, ID_EMPOTHER,     SZ_HOURS);
  new TEdit(this, ID_EMPTRAVELOT,  SZ_HOURS);
  new TEdit(this, ID_EMPINSTALLOT, SZ_HOURS);
  new TEdit(this, ID_EMPENGINOT,   SZ_HOURS);
  new TEdit(this, ID_EMPASBUILTOT, SZ_HOURS);
  new TEdit(this, ID_EMPSURVEYOT,  SZ_HOURS);
  new TEdit(this, ID_EMPTESTOT,    SZ_HOURS);
  new TEdit(this, ID_EMPQUALITYOT, SZ_HOURS);
  new TEdit(this, ID_EMPREWORKOT,  SZ_HOURS);
  new TEdit(this, ID_EMPSTAGINGOT, SZ_HOURS);
  new TEdit(this, ID_EMPDELIVEROT, SZ_HOURS);
  new TEdit(this, ID_EMPPREWIREOT, SZ_HOURS);
  new TEdit(this, ID_EMPOTHEROT,   SZ_HOURS);
  new TEdit(this, ID_EXMILEAGE,    SZ_EXP);
  new TEdit(this, ID_EXPARK,       SZ_EXP);
  new TEdit(this, ID_EXGAS,        SZ_EXP);
  new TEdit(this, ID_EXMEALS,      SZ_EXP);
  new TEdit(this, ID_EXHOTEL,      SZ_EXP);
  new TEdit(this, ID_EXPERDEIM,    SZ_EXP);
  new TEdit(this, ID_EXAIRLINE,    SZ_EXP);
  new TEdit(this, ID_EXRENTAL,     SZ_EXP);
  new TEdit(this, ID_EXOTHER,      SZ_EXP);
  SetTransferBuffer(&tsData);
  }

//  -------------------------------- TTSheetDlg member    GetWindowClass
void  TTSheetDlg :: GetWindowClass(WNDCLASS& wc)
  {
  TDialog :: GetWindowClass(wc);
  wc.lpfnWndProc = BWCCDefDlgProc;
  wc.hIcon = LoadIcon(GetApplication()->hInstance, ICON_TIMESHEET);
  }

//  -------------------------------- TTSheetDlg member    DLGSave
void  TTSheetDlg :: DLGSave(TMessage&)
  {
  TransferData(TF_GETDATA);
  }

//  -------------------------------- TTSheetDlg member    DLGQuit
void  TTSheetDlg :: DLGQuit(TMessage&)
  {
  CloseWindow();
  }

//  -------------------------------- TTSheetDlg member    DLGNew
  /* using memset(..) corrupts the combobox data pointer
   * so each element is cleared individually
   */

void  TTSheetDlg :: DLGNew(TMessage&)
  {
  tsData.Date[0]     = '\0';
  tsData.TEO[0]      = '\0';
  tsData.Site[0]     = '\0';
  tsData.State[0]    = '\0';
  tsData.Hrs_C[0]    = '\0';
  tsData.Hrs_I[0]    = '\0';
  tsData.Hrs_E[0]    = '\0';
  tsData.Hrs_A[0]    = '\0';
  tsData.Hrs_S[0]    = '\0';
  tsData.Hrs_T[0]    = '\0';
  tsData.Hrs_Q[0]    = '\0';
  tsData.Hrs_R[0]    = '\0';
  tsData.Hrs_WS[0]   = '\0';
  tsData.Hrs_WD[0]   = '\0';
  tsData.Hrs_P[0]    = '\0';
  tsData.Hrs_O[0]    = '\0';
  tsData.HrsOT_C[0]  = '\0';
  tsData.HrsOT_I[0]  = '\0';
  tsData.HrsOT_E[0]  = '\0';
  tsData.HrsOT_A[0]  = '\0';
  tsData.HrsOT_S[0]  = '\0';
  tsData.HrsOT_T[0]  = '\0';
  tsData.HrsOT_Q[0]  = '\0';
  tsData.HrsOT_R[0]  = '\0';
  tsData.HrsOT_WS[0] = '\0';
  tsData.HrsOT_WD[0] = '\0';
  tsData.HrsOT_P[0]  = '\0';
  tsData.HrsOT_O[0]  = '\0';
  tsData.Mileage[0]  = '\0';
  tsData.ParkToll[0] = '\0';
  tsData.Gas[0]      = '\0';
  tsData.Meals[0]    = '\0';
  tsData.Hotel[0]    = '\0';
  tsData.PerDeim[0]  = '\0';
  tsData.Airline[0]  = '\0';
  tsData.Rental[0]   = '\0';
  tsData.Other[0]    = '\0';

  strcpy(tsData.Site, tsData.Emps->Selection);  // test the transfer
  sprintf(tsData.State, "VA");                  // buffer for proper
  sprintf(tsData.PerDeim, "  455.00");          // operation
  sprintf(tsData.TEO, "B2H03030600");
  sprintf(tsData.Hrs_I, " 40.0");
  TransferData(TF_SETDATA);
  }

//  -------------------------------- constructor          TProjWindow
TProjWindow :: TProjWindow(PTWindowsObject AParent, LPSTR Title)
                         : TWindow(AParent, Title)
  {
  tsData.Emps = new TComboBoxData();

  tsData.Emps->AddString("Tom");
  tsData.Emps->AddString("Dick");
  tsData.Emps->AddString("Harry");
  tsData.Emps->AddString("Clinton, Bill");
  tsData.Emps->AddString("Truman, Harry");
  tsData.Emps->AddString("Stalin, Joseph");
  tsData.Emps->AddString("Flowers, Jenny");
  tsData.Emps->AddString("Leno, Jay");
  tsData.Emps->AddString("Washington, George");
  tsData.Emps->AddString("Borland, Frank");
  tsData.Emps->AddString("Arbuckle, John");
  tsData.Emps->AddString("Bardot, Bridgett");
  tsData.Emps->AddString("Tom, Uncle");
  tsData.Emps->AddString("Shmoe, Joe");
  tsData.Emps->AddString("Doe, John");
  tsData.Emps->AddString("Doe, Jane");
  tsData.Emps->AddString("Albert, Eddie", TRUE);     // One of these names
  tsData.Emps->AddString("Pele");                    // must be selected
  tsData.Emps->AddString("Carson, Johnny");          // to avoid bad things
  tsData.Emps->AddString("Monster, Frankenstein");   // when using the xfer
  tsData.Emps->AddString("Stoker, Bram");            // buffer while the combo
  tsData.Emps->AddString("Dracula, Count");          // box pointer points
  tsData.Emps->AddString("Clark, Petula");           // to a NULL!
  tsData.Emps->AddString("Steinbeck, John");
  tsData.Emps->AddString("Skywalker, Luke");
  tsData.Emps->AddString("Crabbe, Buster");
  tsData.Emps->AddString("Chu, Fuman");
  tsData.Emps->AddString("Cody, Commander");
  tsData.Emps->AddString("Perot, Ross");
  tsData.Emps->AddString("Lincoln, Abe");
  tsData.Emps->AddString("Jones, Jennifer");
  tsData.Emps->AddString("Rivers, Joan");
  tsData.Emps->AddString("Clampet, Jed");
  tsData.Emps->AddString("Bodine, Jethro");
  tsData.Emps->AddString("Taylor, Opie");
  tsData.Emps->AddString("Parker, judge");
  tsData.Emps->AddString("Larson, Gary");
  tsData.Emps->AddString("Capp, Al");
  tsData.Emps->AddString("Tracy, Dick");
  tsData.Emps->AddString("Hulk, Incredible");
  tsData.Emps->AddString("Head, PotatoE");
  }

//  -------------------------------- destructor           TProjWindow
TProjWindow :: ~TProjWindow()
  {
  if(tsData.Emps) delete tsData.Emps;
  }

//  -------------------------------- TProjWindow member   GetWindowclass
void  TProjWindow ::  GetWindowClass(WNDCLASS& wc)
  {
  TWindow ::  GetWindowClass(wc);
  wc.hIcon =  LoadIcon(GetApplication()->hInstance, ICON_MAIN);
  wc.lpszMenuName = MENU_MAIN;
  }

//  -------------------------------- TProjWindow member   TSheetMakeDlg
void  TProjWindow ::  TSheetMakeDlg(TMessage&)
  {
  if(CreateTSheet && IsWindow(CreateTSheet->HWindow))
    {
    SetActiveWindow(CreateTSheet->HWindow);
    }
  else
    {
    CreateTSheet = new TTSheetDlg(this);
    GetApplication()->MakeWindow(CreateTSheet);
    CreateTSheet->Show(SW_SHOW);
  } }

//  -------------------------------- TProjWindow member   HelpAbout
/* ---------[FUTURE ADD ON]---------
 * void  TProjWindow ::  HelpAbout(TMessage&)
 * {
 * GetApplication()->ExecDialog(new TAboutDlg(this));
 * }
 */

//  -------------------------------- TProj member         InitMainWindow
void  TProj :: InitMainWindow()
  {
  MainWindow = new TProjWindow(NULL, MAIN_WINDOW);
  }

//  -------------------------------- main
int PASCAL WinMain(HINSTANCE AnInstance,
                   HINSTANCE APrevInstance,
                   LPSTR  ACmdLine,
                   int    ACmdShow)
  {
  TProj Proj(MAIN_WINDOW,
             AnInstance,
             APrevInstance,
             ACmdLine,
             ACmdShow);
  Proj.nCmdShow = SW_SHOWMAXIMIZED;
  Proj.Run();
  return(Proj.Status);
  }