/*                            proj.hpp
 * ****************************************************************
 * Copyright (c) Telematics Inc., 1992,  All rights reserved
 * Original Version: 09-22-92 02:21pm
 * Use with proj.cpp
 *
 * SEE NOTICE ATTACHED TO PROJ.CPP
 *
 * ****************************************************************
 */

#ifndef  PROJ_CPP       // --- PROJ_CPP
#define  EXTERN extern
#else
#define  EXTERN
#endif                  // --- PROJ_CPP

//  -------------------------------- constant int Sizeofcharstrings
  /*
   * SZ_SITE and SZ_EMPNAME are made the same because both fields 
   * are exchanged in the program to test the transfer buffer
   */

EXTERN const int SZ_MAXPRJ        = 300;
EXTERN const int SZ_MAXEMP        = 100;
EXTERN const int SZ_NBR           =   5;
EXTERN const int SZ_SS            =  10;
EXTERN const int SZ_LNAME         =  16;
EXTERN const int SZ_FNAME         =  11;
EXTERN const int SZ_MI            =   2;
EXTERN const int SZ_ADD1          =  31;
EXTERN const int SZ_ADD2          =  16;
EXTERN const int SZ_CITY          =  21;
EXTERN const int SZ_STATE         =   3;
EXTERN const int SZ_ZIP           =  11;
EXTERN const int SZ_PHONE         =  11;
EXTERN const int SZ_TITLE         =   2;
EXTERN const int SZ_DATE          =   9;
EXTERN const int SZ_TEO           =  15;
EXTERN const int SZ_SITE          =  25;
EXTERN const int SZ_SON           =   8;
EXTERN const int SZ_EQ            =  69;
EXTERN const int SZ_PCT           =   4;
EXTERN const int SZ_NOTE1         =  66;
EXTERN const int SZ_NOTE          =  71;
EXTERN const int SZ_ENGBY         =  13;
EXTERN const int SZ_CUST          =  17;
EXTERN const int SZ_SUPV          =  13;
EXTERN const int SZ_PO            =   8;
EXTERN const int SZ_CODE          =   7;
EXTERN const int SZ_CLLIE         =  13;
EXTERN const int SZ_BASE          =   6;
EXTERN const int SZ_EMPNAME       =  SZ_SITE;
EXTERN const int SZ_HOURS         =   6;
EXTERN const int SZ_EXP           =  11;

EXTERN const int IDM_TSHEETEDIT   = 101;
EXTERN const int IDM_LEAVEPROGRAM = 102;

#ifndef  PROJ_HPP       // ----- PROJ_HPP
#define  PROJ_HPP

#include <combobox.h>
#include "tsheet.hpp"

//  -------------------------------- constants
LPSTR DIALOG_TIMESHEET = "bordlg_TSheet";
LPSTR MAIN_WINDOW      = "T--------s Projects";
LPSTR ICON_TIMESHEET   = "Timesheet";
LPSTR ICON_MAIN        = "Project";
LPSTR MENU_MAIN        = "MainMenu";

//  -------------------------------- Transfer buffer for Dialog
char  EmpName[50][SZ_EMPNAME];

struct TtsData
  {
  PTComboBoxData Emps;

  char    Date[SZ_DATE];
  char    TEO[SZ_TEO];
  char    Site[SZ_SITE];    
                               // of Transfer buffer
  char    State[SZ_STATE];
       // regular
  char    Hrs_C[SZ_HOURS];     // Travel
  char    Hrs_I[SZ_HOURS];     // Install
  char    Hrs_E[SZ_HOURS];     // Engineering
  char    Hrs_A[SZ_HOURS];     // As Built
  char    Hrs_S[SZ_HOURS];     // Site Survey
  char    Hrs_T[SZ_HOURS];     // Test
  char    Hrs_Q[SZ_HOURS];     // Quality
  char    Hrs_R[SZ_HOURS];     // Rework
  char    Hrs_WS[SZ_HOURS];    // Staging
  char    Hrs_WD[SZ_HOURS];    // Delivery
  char    Hrs_P[SZ_HOURS];     // Prewire
  char    Hrs_O[SZ_HOURS];     // Other
       // overtime
  char    HrsOT_C[SZ_HOURS];   // Travel
  char    HrsOT_I[SZ_HOURS];   // Install
  char    HrsOT_E[SZ_HOURS];   // Engineering
  char    HrsOT_A[SZ_HOURS];   // As Built
  char    HrsOT_S[SZ_HOURS];   // Site Survey
  char    HrsOT_T[SZ_HOURS];   // Test
  char    HrsOT_Q[SZ_HOURS];   // Quality
  char    HrsOT_R[SZ_HOURS];   // Rework
  char    HrsOT_WS[SZ_HOURS];  // Staging
  char    HrsOT_WD[SZ_HOURS];  // Delivery
  char    HrsOT_P[SZ_HOURS];   // Prewire
  char    HrsOT_O[SZ_HOURS];   // Other
       // expenses
  char    Mileage[SZ_EXP];
  char    ParkToll[SZ_EXP];
  char    Gas[SZ_EXP];
  char    Meals[SZ_EXP];
  char    Hotel[SZ_EXP];
  char    PerDeim[SZ_EXP];
  char    Airline[SZ_EXP];
  char    Rental[SZ_EXP];
  char    Other[SZ_EXP];
  } tsData;

char *StateList =
  {
  "AL~AK~AZ~AR~CA~CO~CT~DE~DC~FL~GA~HI~ID~IL~IN~IA~KS"
  "KY~LA~ME~MD~MA~MI~MN~MS~MO~MT~NE~NV~NH~NJ~NM~NY~NC"
  "ND~OH~OK~OR~PA~RI~SC~SD~TN~TX~UT~VA~VT~WA~WV~WI~WY"
  };

//  -------------------------------- class declaration    TAboutProg TDlg
/* ---------[FUTURE ADD ON]---------
 * class TAboutProj : public TDialog
 * {
 * public:
 * TAboutProj(PTWindowsObject AParent)
 *          : TDialog(AParent, "DIALOG_ABOUT") {}
 * };
 */

//  -------------------------------- class declaration    TValidate  TEdit
class TValidate : public TEdit       // These validation classes via
  {                                  // Ted Fasion "Borland C++ Object
  public:                            // Oriented Programming" SAMS
  char  buffer[100];
  TValidate(PTWindowsObject AParent, int ResourceId, int Length)
           :TEdit(AParent, ResourceId, Length) {}
  virtual WORD  Transfer(Pvoid, WORD);
  virtual char* CharacterSet();
  virtual int   Valid(char*);
  virtual BOOL  CanClose();
  virtual void  ErrorMessage(char*);
  virtual void  EmptyMessage(char*);
  };

//  -------------------------------- class declaration    TStateEdit
class TStateEdit :  public TValidate
  {
  public:
  TStateEdit(PTWindowsObject AParent, int ResourceId)
           : TValidate(AParent, ResourceId, SZ_STATE) {}
  virtual int   Valid(char*);
  virtual void  ErrorMessage(char*);
  };

//  -------------------------------- class declaration    TTSheetDlg TDialog
class TTSheetDlg : public  TDialog
  {
  public:
  TTSheetDlg(PTWindowsObject);
  LPSTR GetClassName() {return DIALOG_TIMESHEET;}
  void  GetWindowClass(WNDCLASS&);
  virtual void DLGSave(TMessage&) = [ID_FIRST+ID_TSHEETSAVE];
  virtual void DLGQuit(TMessage&) = [ID_FIRST+ID_TSHEETQUIT];
  virtual void DLGNew(TMessage&)  = [ID_FIRST+ID_TSHEETNEW];
  };

//  -------------------------------- class declaration    TProjWindow TWindow
class TProjWindow : public  TWindow
  {
  public:
  TProjWindow(PTWindowsObject AParent, LPSTR Title);
  ~TProjWindow();
  LPSTR GetClassName()  {return MAIN_WINDOW;}
  void  GetWindowClass(WNDCLASS&);
  virtual void  TSheetMakeDlg(TMessage&)  = [CM_FIRST + IDM_TSHEETEDIT];
  virtual void  LeaveProgram(TMessage&)   = [CM_FIRST + IDM_LEAVEPROGRAM]
    {
    CloseWindow();
  } };

//  -------------------------------- class declaration    TProj application
class TProj : public TApplication
  {
  public:
  TProj(LPSTR AName, HINSTANCE AnInstance, HINSTANCE APrevInstance,
        LPSTR ACmdLine, int ACmdShow)
       :TApplication(AName, AnInstance, APrevInstance,
                     ACmdLine, ACmdShow) {};
  virtual void InitMainWindow();
  };

#endif                  //  PROJ_HPP
//  end of file